//////////////////////////////////////////////////////////////////
//Fluchtdiagramm der Standardmap
//Methode: Es wird bei hier 50 Iterationen der maximale Abstand der y-Werte 
//zur Codierung der Farbe verwendet.
//Mit Linksklick zweifache Vergrößerung
//Mit Rechtsklick Trajektorie am Ort. (Fluchtdiagramm wird transparent)
//Auf die verschiedenen Informationen im Bild bei Links- und Rechtsklick achten!
//Trajektorien werden nur im Bereich 0 < x < 2*Math.PI und -Math.PI < y < Math.PI angezeigt.
//Bis zu 1 000 000 -fache Vergrößerungen sind möglich
/////////////////////////////////////////////////////////////////
double xU = 0; double xO = 2*Math.PI;
double yU = -Math.PI  ; double yO = Math.PI;
 
ArrayList<MyThread> workers;
double xmin = 0; 
double ymin = -Math.PI; 
double wh = 2*Math.PI;
int maxiterations = 50; 
int anzahlThreads = Runtime.getRuntime().availableProcessors();//Bild ohne Math.PIxelfehler wähle anzahlThreads =1
double K = 0.971635;
//double K = 0.5;//Alternative
PImage bild, bildGedreht, bildZurueckGedreht;
float vFaktor = 1  ;
boolean zeichnen,trajektZeichnen, schonTransparent, achseZeichnen, bildFertig;

double  xUNeu, xONeu, yUNeu, yONeu,xAlt, yAlt, xNeu, yNeu;
int xK, yK; //Koordinaten der Punkte
int i,  M;

int w = 800; int h = 800; 
double   xH, yH; 
 //double xSpecial , ySpecial;//zu Testzwecken

void setup() {
  background(255);
  colorMode(HSB);
  i=0;
  M = 50000;
  zeichnen = true;
  workers = new  ArrayList<MyThread>(); 
  size(800, 800);
  println("Anzahl Threads: "+anzahlThreads);
  starteThreads(xmin, ymin, maxiterations,  wh);
 
  bild = createImage(width,height,HSB);
  bildGedreht = createImage(width,height,HSB);
  bildZurueckGedreht = createImage(width,height,HSB);
  trajektZeichnen = false;
  schonTransparent = false;
  achseZeichnen = true;
  bildFertig = false;
 
}
////////////////////////////////////////////////////////////////////
void starteThreads(double px, double py, int pmaxiterations, double pwh){
  
  xmin = px; ymin = py;
  maxiterations = pmaxiterations;
 
  wh = pwh;
  for (double y= ymin; y<(ymin+wh); y=y+wh/anzahlThreads) {
        MyThread t = new MyThread(xmin,y,maxiterations,wh/anzahlThreads,K);
        workers.add(t);
        t.start();  
        delay(50);//einzelne Math.PIxelfehler sind so sehr selten
   }  
}
//////////////////////////////////////////////////////////////

void draw() {
 ///////////////////////////////////////////////////
 if(zeichnen){
   
  // die Draw-Methode fügt die PGraphics-Zeichenflächen
  // der Threads zu einem Bild zusammen
  // Warten bis alle Threads fertig sind
 
  for(MyThread t: workers){
      while (t.running){       
            try{
            Thread.sleep(10);  
            }catch (Exception e) {  }  ;                
       }
  }
  
  for (int i =0; i< workers.size(); i++){
    image(workers.get(i).pg,0,i*height/anzahlThreads);
    
  }  
  //Initialisierung der Math.PImages
   bild = get();
   bildGedreht = get();
   bildZurueckGedreht = get();
 
   //weil negativer y-Bereich bisher oben ist: SMath.PIegelung an x-Achse:
  
     for (int i = 0; i < bild.width; i++){
        for (int j = 0; j < bild.height; j++) {
             bildGedreht.set(i,j,bild.get(i,bild.height-j-1));
            
        }
      }

    image(bildGedreht,0,0);  
    bildFertig = true;
    zeichnen = false;  
   
   }

   ////////////////////////////////////////
   if(bildFertig){
      bildFertig = false;
      background(255);
      //tint(255, 160); //aktivieren, wenn die Trajektorien hervorgehoben werden sollen
      image(bild,0,0);
      for (int i = 0; i < bild.width; i++){
        for (int j = 0; j < bild.height; j++) {
             bildZurueckGedreht.set(i,j,bild.get(i,bild.height-j-1));
        }
      }
      background(255);    
      image(bildZurueckGedreht,0,0);
   
       if(achseZeichnen){
          //Zu Beginn einmal Achsen zeichnen
          stroke(255,100);
          line(400,0,400,800);  
          line(0,400,800,400);
          achseZeichnen = false;
     }   
   }  
}
////////////////////////////////////////////////////////
void iteriere(double xH, double yH, int N ,double K){  
  i=0;
  this.K =K;
  xK = yK =0;
  xAlt = (float)xH; 
  yAlt = (float)yH;
  M =   N;
  strokeWeight(2);
  stroke(0);
  while(i <=M){  
       yNeu = yAlt + K*Math.sin(xAlt); 
       xNeu = (xAlt + yNeu) % (2*Math.PI);  
       if(xNeu <0) xNeu = 2*Math.PI+xNeu;//damit  xNeu > 0
       yK = round( map((float)yNeu,(float)yU,(float)yO,h,0));                 
       xK = round (map((float)xNeu,(float)xU,(float)xO,0,w));  
       point(xK,yK);  
       xAlt = xNeu;
       yAlt = yNeu;
       i++; 
  }  
  i=0;   
}

/////////////////////////////////////////////////////////////////
void mousePressed() {
  
  if (mouseButton == LEFT) {
  
     zeichnen = true;  
     achseZeichnen = false;
     background(255);
     workers = new  ArrayList<MyThread>(); 
    // berechne, wo der Mauszeiger im gezeigten Ausschnitt der 
    // Zahlenebene ist (Transformation Math.PIxelposition nach (x,y))
    double x = xmin + wh*mouseX/width;
    double y = ymin + wh*(height-mouseY)/height;//negativer y-Wert muss unten sein
    
     vFaktor = 2*vFaktor; 
     println("Zoomfaktor: "+vFaktor+"-fach"); 
    
     wh*=0.5;
     // bestimme den neuen gezeigten Ausschnitt
    xmin = x-wh/2.0;
    ymin = y-wh/2.0;
    starteThreads(xmin, ymin, maxiterations, wh);
    
  }
    
  if (mouseButton == RIGHT) {
      bild = get();     
     image(bild,0,0); 
     xH = map(mouseX,0,w,(float)xmin,(float)(xmin+wh)); 
     yH = map(mouseY,h,0, (float)ymin,(float)(ymin+wh));

     xU= (float)xmin; xO= (float)(xmin+wh);
     yU =(float)ymin; yO= (float)(ymin+wh);
     
     iteriere(xH,yH,M,K);    
  }

 
}  
/////////////////////////////////////////////////////////////////
void keyPressed() {
  if (key == '+'){
    //maxiterations *= 1.2;
    workers = new  ArrayList<MyThread>(); 
    starteThreads(xmin, ymin, maxiterations,  wh);
  }
  if (key == '-') {
   // maxiterations /= 1.2;
    workers = new  ArrayList<MyThread>(); 
    starteThreads(xmin, ymin, maxiterations,  wh);  
  }
  
  if (key == 's') save("standardMapFlucht.png");
  redraw();
}
/////////////////////////////////////////////////////////////////


//Fluchtdiagramm für die Standardmap 
//Rechenintensiv, daher multithreaded
//(Es kommt wegen der multithreaded Graphic zu einigen wenigen Math.PIxelfehlern)
//////////////////////////////////////////////////////////////////////////////////
public class MyThread extends Thread {  
  double xmin,ymin;
  color farbe;
  PGraphics pg;
  int maxiterations;
  double x0,y0,xAlt,yAlt,xNeu,yNeu;
  double yMin, yMax;
  double wh;
  double K;
  protected boolean running = false;
  

  //-----------------------------------------
  // Thread anlegen und Parameter übergeben
  //-----------------------------------------
  
  public MyThread(double px0, double py0, int pmaxiterations, double pwh, double KFaktor) {
    // benötigte Parameter
    K = KFaktor;
    wh = pwh;
    xmin=px0; ymin=py0; 
    maxiterations = pmaxiterations;
    pg = createGraphics(width,height/anzahlThreads);
    
  }

 //////////////////////////////////////////////////////////////  
  public void run() {
    
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
       // println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println("y: "+ymin,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j = 0; j < pg.height; j++) {
          double x = xmin;
          for (int i = 0; i < pg.width; i++) {
            double D = standardMapIteration(x, y, maxiterations);
            pg.pixels[i+j*pg.width] = colorize(D);       
         
            x += dx;
          }   
          y += dy;
        }
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
   
  }
  
/////////////////////////////////////////////////////////////////////
double standardMapIteration(double xH, double yH, int maxN) {
   yMin = 5;
   yMax =-5;
  //Standardmap Algorithmus zur Berechung des Abstand des Originalpunktes zum Punkt nach maxN Iterationen
  int  maxit = maxN;
  double d = 0;
  x0 = xH; y0=yH; 
  xAlt = xH; yAlt = yH;
 
  int i = 0;
  while (i < maxit) {
    yNeu = (yAlt + K*Math.sin(xAlt)) ;
    xNeu = (xAlt + yNeu) ;  
    //Der Wertebereich wird hier nicht auf den Definitionsbereich eingeschränkt (modulo)
    //weil sonst die Abstandswerte d sinnlos werden können.
  //  d = d +Math.sqrt((xAlt-xNeu)*(xAlt-xNeu)+(yAlt-yNeu)*(yAlt-yNeu)); 
    if(yNeu < yMin)  yMin = yNeu;
    if(yNeu > yMax)  yMax = yNeu;
    xAlt = xNeu;yAlt = yNeu;
    
    i++;
  }
   d = 200*(yMax-yMin); 
  return d;
 }
}
/////////////////////////////////////////////////////////////
color colorize(double dist) {
  // jedes Math.PIxel wird entsprechend der Anzahl Iterationen eingefärbt
   color col; 
      dist = dist%256;
      
       col = color((int)(dist),255,255); 
       //alternativ:
       //col = color((int)(dist+128)%255,255,(int)(6*dist)%255);   
    return col; 
  
}
